diff --git a/build b/build
index 305849f..93ec1d7 100755
--- a/build
+++ b/build
@@ -8,11 +8,11 @@ ocamlyacc piparser.mly
 ocamllex pilexer.mll
 ocamlyacc pitparser.mly
 ocamllex pitlexer.mll
-ocamlopt -o ../proverif parsing_helper.mli parsing_helper.ml stringmap.mli stringmap.ml ptree.mli piptree.mli pitptree.mli types.mli pitypes.mli param.mli param.ml parser.mli parser.ml lexer.ml queue.mli queue.ml terms.mli terms.ml termslinks.mli termslinks.ml display.mli display.ml history.mli history.ml termsEq.mli termsEq.ml pievent.mli pievent.ml weaksecr.mli weaksecr.ml noninterf.mli noninterf.ml selfun.mli selfun.ml rules.mli rules.ml syntax.mli syntax.ml tsyntax.mli tsyntax.ml piparser.mli piparser.ml pilexer.ml pitparser.mli pitparser.ml pitlexer.ml spassout.mli spassout.ml reduction_helper.mli reduction_helper.ml pisyntax.mli pisyntax.ml pitsyntax.mli pitsyntax.ml pitransl.mli pitransl.ml pitranslweak.mli pitranslweak.ml reduction.mli reduction.ml reduction_bipro.mli reduction_bipro.ml piauth.mli piauth.ml main.ml
+ocamlopt -o ../proverif lists.mli lists.ml parsing_helper.mli parsing_helper.ml stringmap.mli stringmap.ml ptree.mli piptree.mli pitptree.mli types.mli pitypes.mli param.mli param.ml parser.mli parser.ml lexer.ml queue.mli queue.ml terms.mli terms.ml termslinks.mli termslinks.ml display.mli display.ml optimisation.mli optimisation.ml history.mli history.ml termsEq.mli termsEq.ml pievent.mli pievent.ml weaksecr.mli weaksecr.ml noninterf.mli noninterf.ml selfun.mli selfun.ml rules.mli rules.ml syntax.mli syntax.ml tsyntax.mli tsyntax.ml piparser.mli piparser.ml pilexer.ml pitparser.mli pitparser.ml pitlexer.ml spassout.mli spassout.ml reduction_helper.mli reduction_helper.ml pisyntax.mli pisyntax.ml pitsyntax.mli pitsyntax.ml pitransl.mli pitransl.ml pitranslweak.mli pitranslweak.ml reduction.mli reduction.ml reduction_bipro.mli reduction_bipro.ml piauth.mli piauth.ml main.ml
 
 ocamllex lexertotex.mll
 ocamllex pitlexertotex.mll
-ocamlopt -o ../proveriftotex parsing_helper.cmx param.cmx piparser.cmx pilexer.cmx pitparser.cmx pitlexer.cmx fileprint.ml lexertotex.ml pitlexertotex.ml proveriftotex.ml
+ocamlopt -o ../proveriftotex lists.mli lists.ml parsing_helper.cmx param.cmx piparser.cmx pilexer.cmx pitparser.cmx pitlexer.cmx fileprint.ml lexertotex.ml pitlexertotex.ml proveriftotex.ml
 
 if [ -f xtime.c ]
 then
diff --git a/build.bat b/build.bat
index 7ae0ace..518be05 100755
--- a/build.bat
+++ b/build.bat
@@ -6,10 +6,10 @@ ocamlyacc piparser.mly
 ocamllex pilexer.mll
 ocamlyacc pitparser.mly
 ocamllex pitlexer.mll
-ocamlc -o ..\proverif.exe parsing_helper.mli parsing_helper.ml stringmap.mli stringmap.ml ptree.mli piptree.mli pitptree.mli types.mli pitypes.mli param.mli param.ml parser.mli parser.ml lexer.ml queue.mli queue.ml terms.mli terms.ml display.mli display.ml termslinks.mli termslinks.ml history.mli history.ml termsEq.mli termsEq.ml pievent.mli pievent.ml weaksecr.mli weaksecr.ml noninterf.mli noninterf.ml selfun.mli selfun.ml rules.mli rules.ml syntax.mli syntax.ml tsyntax.mli tsyntax.ml piparser.mli piparser.ml pilexer.ml pitparser.mli pitparser.ml pitlexer.ml spassout.mli spassout.ml reduction_helper.mli reduction_helper.ml pisyntax.mli pisyntax.ml pitsyntax.mli pitsyntax.ml pitransl.mli pitransl.ml pitranslweak.mli pitranslweak.ml reduction.mli reduction.ml reduction_bipro.mli reduction_bipro.ml piauth.mli piauth.ml main.ml
+ocamlc -o ..\proverif.exe lists.mli lists.ml parsing_helper.mli parsing_helper.ml stringmap.mli stringmap.ml ptree.mli piptree.mli pitptree.mli types.mli pitypes.mli param.mli param.ml parser.mli parser.ml lexer.ml queue.mli queue.ml terms.mli terms.ml display.mli display.ml termslinks.mli termslinks.ml optimisation.mli optimisation.ml history.mli history.ml termsEq.mli termsEq.ml pievent.mli pievent.ml weaksecr.mli weaksecr.ml noninterf.mli noninterf.ml selfun.mli selfun.ml rules.mli rules.ml syntax.mli syntax.ml tsyntax.mli tsyntax.ml piparser.mli piparser.ml pilexer.ml pitparser.mli pitparser.ml pitlexer.ml spassout.mli spassout.ml reduction_helper.mli reduction_helper.ml pisyntax.mli pisyntax.ml pitsyntax.mli pitsyntax.ml pitransl.mli pitransl.ml pitranslweak.mli pitranslweak.ml reduction.mli reduction.ml reduction_bipro.mli reduction_bipro.ml piauth.mli piauth.ml main.ml
 
 ocamllex lexertotex.mll
 ocamllex pitlexertotex.mll
-ocamlc -o ..\proveriftotex.exe parsing_helper.mli parsing_helper.ml ptree.mli piptree.mli pitptree.mli types.mli param.mli param.ml piparser.mli piparser.ml pilexer.ml pitparser.mli pitparser.ml pitlexer.ml fileprint.ml lexertotex.ml pitlexertotex.ml proveriftotex.ml
+ocamlc -o ..\proveriftotex.exe lists.mli lists.ml parsing_helper.mli parsing_helper.ml ptree.mli piptree.mli pitptree.mli types.mli param.mli param.ml piparser.mli piparser.ml pilexer.ml pitparser.mli pitparser.ml pitlexer.ml fileprint.ml lexertotex.ml pitlexertotex.ml proveriftotex.ml
 
 cd ..
diff --git a/examples/pi/state/Garay-Mackenzie.pi b/examples/pi/state/Garay-Mackenzie.pi
new file mode 100644
index 0000000..b231016
--- /dev/null
+++ b/examples/pi/state/Garay-Mackenzie.pi
@@ -0,0 +1,255 @@
+(* Two-party instance of the Garay and Mackenzie contract signing protocol. *)
+
+param verboseClauses = short.
+param propagateState = true.
+
+(* Public channel. *)
+free Internet.
+
+(* Value used for initial states. *)
+free Init.
+
+(* Commands. *)
+free Abort.
+free Resolve_1.
+free Resolve_2.
+
+(* Trusted party states. *)
+free Aborted.
+free Resolved_2.
+free Resolved_1.
+
+(* Contract for which the security properties are verified. *)
+free Witnessing_Contract.
+
+(* Trusted party's secret key. *)
+private free Trusted_Party_Secret_Key.
+
+(* Secret keys. *)
+free Secret_Key_1.
+free Secret_Key_2.
+
+(* Cryptography. *)
+fun Public_Key /1.
+fun Sign       /2.
+fun PCS        /4.
+
+reduc Check_Get_Message (Public_Key (Secret_Key),
+                         Sign (Secret_Key, Message))
+        = Message.
+
+fun OK     /0.
+
+(* Check private contract signature. *)
+reduc Check_PCS (Contract,
+                 Public_Key (Secret_Key_X),
+                 Public_Key_Y,
+                 Public_Key_Z,
+                 PCS (Secret_Key_X,
+                      Public_Key_Y,
+                      Public_Key_Z,
+                      Contract))
+        = OK.
+
+(* Convert a private contract signature to a signature. *)
+reduc Convert_PCS (Public_Key_Z,
+                   PCS (Secret_Key_X,
+                        Public_Key_Y,
+                        Public_Key (Secret_Key_Z),
+                        Contract))
+        = Sign (Secret_Key_X, Contract).
+
+(* State of the trusted party. (mode, signatures) pair. *)
+
+cell Trusted_Party_State := (Init, Init).
+
+
+query attacker:Some_State,
+               ( Sign (Trusted_Party_Secret_Key,
+                       ( ( Contract,
+                           ( Public_Key (Secret_Key_1),
+                             Public_Key (Secret_Key_2) )),
+                         Sign (Secret_Key_1,
+                               ( Contract,
+                                 ( Public_Key (Secret_Key_1),
+                                   Public_Key (Secret_Key_2) ))))),
+                 Sign (Trusted_Party_Secret_Key,
+                       ( Sign (Secret_Key_1, Contract),
+                         Sign (Secret_Key_2, Contract)))) .
+
+let T' =
+  out (Internet, Public_Key (Trusted_Party_Secret_Key));
+  Trusted_Party | ! Stateless_Trusted_Party .
+
+(* Precise model of the trusted party for the witnessing contract. *)
+
+let Trusted_Party =
+  (* Contract for which the security properties will
+     be verified. *)
+  new Witnessing_Contract;
+
+  out (Internet, Witnessing_Contract);
+  let Public_Key_1 = Public_Key (Secret_Key_1) in
+  let Public_Key_2 = Public_Key (Secret_Key_2) in
+  ( ! Abort_1_Process 
+  | ! Resolve_2_Process
+  | ! Resolve_1_Process ) .
+
+let Abort_1_Process =
+  in (Internet, ( Command,
+                  ( ( Contract, Parties ),
+                    Signature )));
+  if Command = Abort then
+    if Parties = ( Public_Key_1, Public_Key_2 ) then
+      if Contract = Witnessing_Contract then
+        if Check_Get_Message (Public_Key_1, Signature)
+          = ( Contract, Parties )
+        then
+          lock (Trusted_Party_State);
+          read Trusted_Party_State as
+            ( Current_State, Current_Signatures );
+          if Current_State = Aborted then
+            unlock (Trusted_Party_State);
+            out (Internet, Current_Signatures)
+          else if Current_State = Init then
+            let TP_Signature = Sign (Trusted_Party_Secret_Key,
+                                  ( ( Contract, Parties ),
+                                    Signature )) in
+            Trusted_Party_State := ( Aborted, TP_Signature );
+            unlock (Trusted_Party_State);
+            out (Internet, TP_Signature) .
+
+let Resolve_2_Process =
+  in (Internet, ( Command,
+                  ( PCS_1, Signature_2 )));
+  let Contract = Check_Get_Message (Public_Key_2, Signature_2) in
+  if Contract = Witnessing_Contract then
+    if Check_PCS (Contract,
+                  Public_Key_1,
+                  Public_Key_2,
+                  Public_Key (Trusted_Party_Secret_Key),
+                  PCS_1) = OK
+    then
+      lock (Trusted_Party_State);
+      read Trusted_Party_State as ( Current_Status, Current_Signatures );
+      if Current_Status = Resolved_2 then
+        unlock (Trusted_Party_State);
+        out (Internet, Current_Signatures)
+      else if Current_Status = Init then
+        let Signature_1 = Convert_PCS (Trusted_Party_Secret_Key, PCS_1) in
+        let TP_Signature = Sign (Trusted_Party_Secret_Key,
+                              ( Signature_1, Signature_2 )) in
+        Trusted_Party_State := ( Resolved_2, TP_Signature );
+        unlock (Trusted_Party_State);
+        out (Internet, TP_Signature) .
+
+let Resolve_1_Process =
+  in (Internet, ( Command,
+                  ( Signature_1, PCS_2 )));
+  let Contract = Check_Get_Message (Public_Key_1, Signature_1) in
+  if Contract = Witnessing_Contract then
+    if Check_PCS (Contract,
+                  Public_Key_2,
+                  Public_Key_1,
+                  Public_Key (Trusted_Party_Secret_Key),
+                  PCS_2) = OK
+    then
+      lock (Trusted_Party_State);
+      read Trusted_Party_State as ( Current_Status, Current_Signatures );
+      if Current_Status = Resolved_1 then
+        unlock (Trusted_Party_State);
+        out (Internet, Current_Signatures)
+      else if Current_Status = Init then
+        let Signature_2 = Convert_PCS (Trusted_Party_Secret_Key, PCS_2) in
+        let TP_Signature = Sign (Trusted_Party_Secret_Key,
+                              ( Signature_1, Signature_2 )) in
+        Trusted_Party_State := ( Resolved_1, TP_Signature );
+        unlock (Trusted_Party_State);
+        out (Internet, TP_Signature) .
+
+(* Approximate, stateless model of the trusted party for contracts other than
+   the witnessing contract. *)
+
+let Stateless_Trusted_Party =
+  new Bogus_Contract;
+  out (Internet, Bogus_Contract);
+  in (Internet, Public_Key_1);
+  in (Internet, Public_Key_2);
+  ( ! Stateless_Abort_1_Process
+  | ! Stateless_Resolve_2_Process
+  | ! Stateless_Resolve_1_Process ) .
+
+
+let Stateless_Abort_1_Process =
+  in (Internet, ( Command,
+                  ( ( Contract, Parties ),
+                    Signature )));
+  if Command = Abort then
+    if Parties = ( Public_Key_1, Public_Key_2 ) then
+      if Contract = Bogus_Contract then
+        if Check_Get_Message (Public_Key_1, Signature)
+          = ( Contract, Parties )
+        then
+          lock (Trusted_Party_State);
+          read Trusted_Party_State as
+            ( Current_State, Current_Signatures );
+          if Current_State = Aborted then
+            unlock (Trusted_Party_State);
+            out (Internet, Current_Signatures)
+          else if Current_State = Init then
+            let TP_Signature = Sign (Trusted_Party_Secret_Key,
+                                  ( ( Contract, Parties ),
+                                    Signature )) in
+            Trusted_Party_State := ( Aborted, TP_Signature );
+            unlock (Trusted_Party_State);
+            out (Internet, TP_Signature) .
+
+let Stateless_Resolve_2_Process =
+  in (Internet, ( Command,
+                  ( PCS_1, Signature_2 )));
+  let Contract = Check_Get_Message (Public_Key_2, Signature_2) in
+  if Contract = Bogus_Contract then
+    if Check_PCS (Contract,
+                  Public_Key_1,
+                  Public_Key_2,
+                  Public_Key (Trusted_Party_Secret_Key),
+                  PCS_1) = OK
+    then
+      lock (Trusted_Party_State);
+      read Trusted_Party_State as ( Current_Status, Current_Signatures );
+      if Current_Status = Resolved_2 then
+        unlock (Trusted_Party_State);
+        out (Internet, Current_Signatures)
+      else if Current_Status = Init then
+        let Signature_1 = Convert_PCS (Trusted_Party_Secret_Key, PCS_1) in
+        let TP_Signature = Sign (Trusted_Party_Secret_Key,
+                              ( Signature_1, Signature_2 )) in
+        Trusted_Party_State := ( Resolved_2, TP_Signature );
+        unlock (Trusted_Party_State);
+        out (Internet, TP_Signature) .
+
+let Stateless_Resolve_1_Process =
+  in (Internet, ( Command,
+                  ( Signature_1, PCS_2 )));
+  let Contract = Check_Get_Message (Public_Key_1, Signature_1) in
+  if Contract = Bogus_Contract then
+    if Check_PCS (Contract,
+                  Public_Key_2,
+                  Public_Key_1,
+                  Public_Key (Trusted_Party_Secret_Key),
+                  PCS_2) = OK
+    then
+      lock (Trusted_Party_State);
+      read Trusted_Party_State as ( Current_Status, Current_Signatures );
+      if Current_Status = Resolved_1 then
+        unlock (Trusted_Party_State);
+        out (Internet, Current_Signatures)
+      else if Current_Status = Init then
+        let Signature_2 = Convert_PCS (Trusted_Party_Secret_Key, PCS_2) in
+        let TP_Signature = Sign (Trusted_Party_Secret_Key,
+                              ( Signature_1, Signature_2 )) in
+        Trusted_Party_State := ( Resolved_1, TP_Signature );
+        unlock (Trusted_Party_State);
+        out (Internet, TP_Signature) .
+
+process Trusted_Party
diff --git a/examples/pi/state/security-device.pi b/examples/pi/state/security-device.pi
new file mode 100644
index 0000000..97aaeb4
--- /dev/null
+++ b/examples/pi/state/security-device.pi
@@ -0,0 +1,67 @@
+(* This is a model of a security device that can be set to work in two modes:
+   "left" mode and "right" mode". The device can be configured only once.
+   The device can then be sent pairs of secrets (a,b) encrypted with its public key.
+   In "left" mode, the device will output a, while in "right" mode it will output b. *)
+
+param verboseClauses = short.
+param propagateState = true.
+param grounding = true.
+
+(* Channel on which left or right is sent to configure the device. *)
+free config.
+
+(* Channel on which the encrypted secrets are sent to the device,
+   and the decrypted secrets are returned. *)
+free decryption.
+
+(* Channel to publish values. *)
+free broadcast.
+
+free unconfigured.
+free left.
+free right.
+
+(* Asymmetric encryption. *)
+fun pk/1.
+fun aenc/3.
+reduc adec(k, aenc(pk(k), random, plaintext)) = plaintext.
+
+(* The device is initially configured to neither "left" nor "right" mode. *)
+cell device_mode := unconfigured.
+
+(* There should not exist a state in which the attacker can know both
+   left_secret and right_secret (from the source_of_secrets process). *)
+query attacker:vs, (left_secret, right_secret).
+
+let device =
+    (* The device broadcasts its public key. *)
+    ! out(broadcast, pk(k)) |
+
+    ! (
+        in(config, new_mode);
+        lock(device_mode);
+        read device_mode as ymode;
+        if ymode = unconfigured then
+            if new_mode = left then device_mode := new_mode; unlock(device_mode)
+            else if new_mode = right then device_mode := new_mode; unlock(device_mode)
+    ) |
+
+    ! (
+        in(decryption, secrets);
+        let (lsecret, rsecret) = adec(k, secrets) in
+        read device_mode as ymode;
+        if ymode = left then out(decryption, lsecret)
+        else if ymode = right then out(decryption, rsecret)
+    )
+.
+
+let source_of_secrets =
+    new random;
+    new left_secret;
+    new right_secret;
+    out(broadcast, aenc(pk(k), random, (left_secret, right_secret)))
+.
+
+process
+    new k;
+    device | ! source_of_secrets
diff --git a/src/display.ml b/src/display.ml
index 8f19c22..cf74b1a 100644
--- a/src/display.ml
+++ b/src/display.ml
@@ -30,6 +30,18 @@ open Pitypes
 
 type cl = CFun | CName | CVar | CPred | CType | CExplain | CKeyword | CConn
 
+(* Convert the integer n into a string corresponding to (n+1)-th *)
+
+let order_of_int n = 
+  (string_of_int (n+1)) ^ 
+  (
+  if (n>=10) && (n<14) then "th" else
+  match (n+1) mod 10 with
+  | 1 -> "st"
+  | 2 -> "nd"
+  | 3 -> "rd"
+  | _ -> "th")
+
 module type LangSig =
 sig
 val indentstring : string
@@ -516,11 +528,13 @@ let concl upper concl tag =
       print_string (if upper then "The message " else "the message ");
       begin
 	match concl with
-	  Pred({p_info = [Attacker(n,_)]} as p, [v]) ->
+	  Pred({p_info = [Attacker(n,_)]} as p, args) ->
+	    let phi, [v] = Lists.head_tail args 1 in
 	    term v;
 	    print_string " may be sent to the attacker";
 	    display_phase p
-	| Pred({p_info = [Mess(n,_)]} as p, [vc;v]) ->
+	| Pred({p_info = [Mess(n,_)]} as p, args) ->
+	    let phi, [vc; v] = Lists.head_tail args 2 in
 	    term v;
 	    print_string " may be sent on channel ";
 	    term vc;
@@ -535,16 +549,37 @@ let concl upper concl tag =
 	    term v;
 	    print_string " may be sent on channel ";
 	    term vc;
-            print_string " (resp. message ";
+	        print_string " (resp. message ";
 	    term v';
 	    print_string " on channel ";
 	    term vc';
- 	    print_string ")";
+	    print_string ")";
 	    display_phase p
 	| _ -> Parsing_helper.internal_error "Unexpected conclusion for OutputTag"
       end;
       print_string " at output ";
       Lang.display_occ occ
+  | AssignmentTag(cell_indices) :: _ ->
+      begin
+        match concl with
+          Pred(p, args) ->
+            let phi = fst (Lists.head_tail args (
+              match p with
+                  { p_info = [Attacker(_,_)]} -> 1
+                | { p_info = [Mess(_,_)]} -> 2
+                | _ -> Parsing_helper.internal_error "Unexpected conclusion for AssignmentTag"
+            )) in
+            let first = (ref true) in
+            (List.iter
+              (fun cell_index ->
+                (print_string ((if (! first) && upper then "The" else if (! first) then "the" else " and the") ^ " cell "
+                  ^ (fst (List.nth (! Param.cells) cell_index))
+                  ^ " may be assigned the value "));
+                (term (List.nth phi cell_index));
+                first := false)
+              cell_indices)
+        | _ -> Parsing_helper.internal_error "Unexpected conclusion for AssignmentTag"
+      end;
   | TestUnifTag occ :: _ | TestUnifTag2 occ :: _ ->
       begin
 	print_string (if upper then "The attacker can make a distinguishing test at " else "the attacker can make a distinguishing test at ");
@@ -732,6 +767,27 @@ let rec display_hyp hyp tag =
   | (h, OutputTag _ :: t) | (h, InsertTag _ :: t) | (h, LetFilterTag _ :: t)
   | (h, BeginEvent _ :: t) ->
       display_hyp h t
+  | (m::h, AssignmentTag(_) :: t) -> display_hyp h t
+  | (m::h, ReadTag(cell_indices) :: t) ->
+    begin
+      display_hyp h t;
+      begin
+        match m with
+          Pred({p_info = [Mess(n,_)]}, args) ->
+            begin
+              let phi, [vc; vm] = (Lists.head_tail args 2) in
+              (List.iter
+                (fun cell_index ->
+                  (print_string ("the cell " ^ (fst (List.nth (! Param.cells) cell_index))
+                    ^ " is in the "));
+                  (display_term (List.nth phi cell_index));
+                  (print_string " state, "))
+                cell_indices)
+            end
+        | _ -> Parsing_helper.internal_error "Unexpected hypothesis for ReadTag"
+      end;
+      newline ()
+    end
   | (h, ReplTag _ :: t) ->
       if !Param.non_interference then
 	if !Param.key_compromise == 1 then
@@ -748,14 +804,16 @@ let rec display_hyp hyp tag =
       display_hyp h t;
       begin
 	match m with
-	  Pred({p_info = [Attacker(n,_)]} as p, [v]) ->
+	  Pred({p_info = [Attacker(n,_)]} as p, args) ->
+	    let phi, [v] = Lists.head_tail args 1 in
 	    print_string "the message ";
 	    display_term v;
 	    print_string " is received from the attacker";
 	    display_phase p;
 	    print_string " at input ";
 	    Lang.display_occ occ
-	| Pred({p_info = [Mess(n,_)]} as p, [vc;v]) ->
+	| Pred({p_info = [Mess(n,_)]} as p, args) ->
+	    let phi, [vc; v] = Lists.head_tail args 2 in
 	    print_string "the message ";
 	    display_term v;
 	    print_string " is received on channel ";
@@ -837,6 +895,7 @@ let rec empty_hyp hyp tags =
   | (h, LetTag _ :: t) | (h, InputPTag _ :: t) | (h, OutputPTag _ :: t) 
   | (h, OutputTag _ :: t) | (h, LetFilterTag _ :: t) | (h, InsertTag _ :: t) 
   | (h, BeginEvent _ :: t) -> empty_hyp h t
+  | (_::h, AssignmentTag _ :: t) -> empty_hyp h t
   | (h, ReplTag _ :: t) ->
       if !Param.non_interference then
 	if !Param.key_compromise == 1 then
@@ -873,7 +932,7 @@ let display_rule_num ((hyp,concl,hist,constra) as rule) =
 	      display_phase p;
 	      print_string ".)"
 	  | Apply(Proj(f,n),p) ->
-	      print_string ("(The attacker applies the " ^ (string_of_int n) ^ "th inverse of function ");
+	      print_string ("(The attacker applies the " ^ (order_of_int n) ^ " inverse of function ");
 	      display_function_name f;
 	      display_phase p;
 	      print_string ".)"
@@ -927,7 +986,7 @@ let display_rule_num ((hyp,concl,hist,constra) as rule) =
 	  | TestUnif ->
 	      print_string "(The attacker can test whether these terms unify.)"
 	  | ProcessRule(tags, _) | ProcessRule2(tags, _, _) -> 
-	      if empty_hyp hyp tags && constra == [] then
+	      if (empty_hyp hyp tags) && (constra == []) then
 		begin
 		  print_string "(";
 		  Std.concl true concl tags;
@@ -1089,7 +1148,7 @@ let rec may_have_else = function
   | Repl(p,_) -> may_have_else p
   | Test _ | Let _ | LetFilter _ -> true
   | Restr(_,p,_) | Event(_,p,_) | Output(_,_,p,_) | Input(_,_,p,_) | Insert(_,p,_) | Get(_,_,p,_) 
-  | Phase(_,p,_) -> may_have_else p
+  | Phase(_,p,_) | Assign(_,p) | ReadAs(_,p) | Lock(_,p) | Unlock(_,p) -> may_have_else p
 
 let display_proc show_occ align proc =
   let display_occ occ =
@@ -1283,6 +1342,31 @@ let display_proc show_occ align proc =
 	  end
 	else
 	  display_process align p
+    | Assign(pairs, p) ->
+        (print_string align);
+        (display_list print_string "," (fst (List.split pairs)));
+        (print_string " := ");
+        (display_list display_term "," (snd (List.split pairs)));
+        display_opt_process align p
+    | ReadAs(pairs, p) ->
+        (print_string align);
+        (print_string "read ");
+        (display_list print_string "," (fst (List.split pairs)));
+        (print_string " as ");
+        (display_list display_pattern "," (snd (List.split pairs)));
+        display_opt_process align p
+    | Lock(cells, p) ->
+        (print_string align);
+        (print_string "lock(");
+        (display_list print_string "," cells);
+        (print_string ")");
+        (display_opt_process align p)
+    | Unlock(cells, p) ->
+        (print_string align);
+        (print_string "unlock(");
+        (display_list print_string "," cells);
+        (print_string ")");
+        (display_opt_process align p)
   and display_opt_process align p =
     match p with
       Nil -> newline()
@@ -1459,10 +1543,11 @@ let display_step_low n =
     end
 
 let display_attacker_fact = function
-    Pred({p_info = [Attacker(n,_)]}, [v]) ->
+    Pred({p_info = [Attacker(n,_)]}, args) ->
+      let phi, [v] = Lists.head_tail args 1 in
       WithLinks.term v;
       if n > 0 then 
-	print_string (" in phase " ^ (string_of_int n))
+    print_string (" in phase " ^ (string_of_int n))
   | Pred({p_info = [AttackerBin(n,_)]}, [v;v']) ->
       WithLinks.term v;
       print_string " (resp. ";
@@ -1567,6 +1652,8 @@ let display_hyp_spec = function
   | OutputPTag o -> print_string "op"; print_string (string_of_int o)
   | InsertTag o ->  print_string "it"; print_string (string_of_int o)
   | GetTag o ->  print_string "gt"; print_string (string_of_int o)
+  | AssignmentTag _ -> print_string "assign"
+  | ReadTag _ -> print_string "read"
 
 let rec display_hyp hyp hl tag =
   match (hyp, hl, tag) with
@@ -1583,6 +1670,27 @@ let rec display_hyp hyp hl tag =
   | (h, hl, OutputPTag _ :: t) | (h, hl, BeginEvent _ :: t)
   | (h, hl, OutputTag _ :: t) | (h, hl, InsertTag _ :: t) ->
       display_hyp h hl t
+  | (m::h, _::hl, AssignmentTag(_) :: t) -> display_hyp h hl t
+  | (m::h, _::hl, ReadTag(cell_indices) :: t) ->
+    begin
+      display_hyp h hl t;
+      begin
+        match m with
+          Pred({p_info = [Mess(n,_)]}, args) ->
+            begin
+              let phi, [vc; vm] = (Lists.head_tail args 2) in
+              (List.iter
+                (fun cell_index ->
+                  (print_string ("the cell " ^ (fst (List.nth (! Param.cells) cell_index))
+                    ^ " is in the "));
+                  (display_term (List.nth phi cell_index));
+                  (print_string " state, "))
+                cell_indices)
+            end
+        | _ -> Parsing_helper.internal_error "Unexpected hypothesis for ReadTag"
+      end;
+      newline ()
+    end
   | (h, hl, ReplTag _ :: t) ->
       if !Param.non_interference then
 	if !Param.key_compromise == 1 then
@@ -1619,7 +1727,8 @@ let rec display_hyp hyp hl tag =
       display_hyp h hl t;
       begin
 	match m with
-	  Pred({p_info = [Attacker(n,_)]} as p, [v]) ->
+	  Pred({p_info = [Attacker(n,_)]} as p, args) ->
+	    let phi, [v] = Lists.head_tail args 1 in
 	    print_string "The message ";
 	    WithLinks.term v;
 	    print_string " that the attacker may have";
@@ -1627,7 +1736,8 @@ let rec display_hyp hyp hl tag =
 	    display_step_low s;
 	    print_string " may be received at input ";
 	    Lang.display_occ occ
-	| Pred({p_info = [Mess(n,_)]} as p, [vc;v]) ->
+	| Pred({p_info = [Mess(n,_)]} as p, args) ->
+	    let phi, [vc; v] = Lists.head_tail args 2 in
 	    print_string "The message ";
 	    WithLinks.term v;
 	    print_string " that may be sent on channel ";
@@ -1655,7 +1765,7 @@ let rec display_hyp hyp hl tag =
 	    WithLinks.term v';
 	    print_string " on channel ";
 	    WithLinks.term vc';
- 	    print_string ")";
+	    print_string ")";
 	    display_phase p;
 	    display_step_low s;
 	    print_string " may be received at input ";
@@ -2050,18 +2160,6 @@ let display_abbrev_table l =
   print_string "Abbreviations:";
   display_item_list display_eq (List.rev l)
 
-(* Convert the integer n into a string corresponding to (n+1)-th *)
-
-let order_of_int n = 
-  (string_of_int (n+1)) ^ 
-  (
-  if (n>=10) && (n<14) then "th" else
-  match (n+1) mod 10 with
-  | 1 -> "st"
-  | 2 -> "nd"
-  | 3 -> "rd"
-  | _ -> "th")
-
 (* Display reduction step *)
 
 let display_step = function
diff --git a/src/display.mli b/src/display.mli
index 18d83a6..b7b9c90 100644
--- a/src/display.mli
+++ b/src/display.mli
@@ -134,6 +134,8 @@ val display_eq_query : Pitypes.eq_query -> unit
 val display_function_name : funsymb -> unit
 val display_phase : predicate -> unit
 
+val display_format : format -> unit
+
 
 module WithLinks :
   sig
diff --git a/src/lists.ml b/src/lists.ml
new file mode 100644
index 0000000..c03e93e
--- /dev/null
+++ b/src/lists.ml
@@ -0,0 +1,21 @@
+let head_tail lst n =
+    let head = ref [] in
+    let tail = ref [] in
+    for i = (List.length lst) downto 1 do
+        if (List.length lst) - i < n then
+            tail := (List.nth lst (i-1)) :: !tail
+        else
+            head := (List.nth lst (i-1)) :: !head
+    done;
+    !head, !tail
+
+let update_list lst n new_value =
+    let i = ref (-1) in
+    List.map (fun x ->
+        i := !i + 1;
+        if !i == n then
+            new_value
+        else
+            x)
+        lst
+
diff --git a/src/lists.mli b/src/lists.mli
new file mode 100644
index 0000000..86bb952
--- /dev/null
+++ b/src/lists.mli
@@ -0,0 +1,12 @@
+(* [a;b;c;d;e] 2 -> [a;b;c], [d;e]
+   Split a list into two.
+   The second list contains the n last elements of lst.
+   The first list contains all the other elements.
+   I.e. head_tail lst n will break the n last elements off lst into
+   a separate list. *)
+
+val head_tail : 'a list -> int -> 'a list * 'a list
+
+(* Return a copy of lst with item n (range 0..length-1)
+   replaced with new_value. *)
+val update_list : 'a list -> int -> 'a -> 'a list
diff --git a/src/main.ml b/src/main.ml
index 8d2f9ab..885b2c7 100644
--- a/src/main.ml
+++ b/src/main.ml
@@ -366,6 +366,8 @@ let anal_file s =
 	    then Parsing_helper.user_error "Queries are incompatible with choice\n";
 	    if (!Param.key_compromise != 0) then
 	      Parsing_helper.user_error "Key compromise is incompatible with choice\n";
+	    if (!Param.has_state = true) then
+	      Parsing_helper.user_error "Cells are incompatible with choice\n";
 
 	    print_string "-- Observational equivalence"; print_newline();
 	    if !Param.html_output then
